/*
* This file is part of Bielefeld Type Library (BTL).
*
* Copyright(c) Frederic Siepmann
* http://opensource.cit-ec.de/projects/btl
*
* This file may be licensed under the terms of of the
* GNU Lesser General Public License Version 3 (the ``LGPL''),
* or (at your option) any later version.
*
* Software distributed under the License is distributed
* on an ``AS IS'' basis, WITHOUT WARRANTY OF ANY KIND, either
* express or implied. See the LGPL for the specific language
* governing rights and limitations.
*
* You should have received a copy of the LGPL along with this
* program. If not, go to http://www.gnu.org/licenses/lgpl.html
* or write to the Free Software Foundation, Inc.,
* 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
*
* The development of this software was supported by the
* Excellence Cluster EXC 277 Cognitive Interaction Technology.
* The Excellence Cluster EXC 277 is a grant of the Deutsche
* Forschungsgemeinschaft (DFG) in the context of the German
* Excellence Initiative.
*
* Contributors: Leon Ziegler, Johannes Wienke, Matthias Schröder, Norman Köster,
* 				Lukas Twardon, Torben Töniges, Annika Rothert, Marian Pohling,
* 				Denis Schulze, Viktor Richter, Birte Carlmeyer, Maikel Linke
*/

#include <boost/test/unit_test.hpp>
#include <boost/test/floating_point_comparison.hpp>

#include <iostream>

#include <sys/time.h>
#include <time.h>

#include "btl/data/vision3d/SRPlaceData.h"
#include "../../utils.h"

using namespace airobots;
using namespace std;
using namespace xmltio;

static const double TOLERANCE = 0.0001;

BOOST_AUTO_TEST_SUITE(SRPlaceDataTest)

BOOST_AUTO_TEST_CASE(testSelfCompatibility) {

	SRPlaceData original("test", 0.4, Timestamp());

	Location originalLoc(SRPlaceData::getTemplate(), SRPlaceData::getBaseTag());
	originalLoc = original;

	cout << originalLoc.getDocumentText(true) << endl;

	SRPlaceData parsed = extract<SRPlaceData>(originalLoc);

	BOOST_REQUIRE_EQUAL(original.getSrPlaceLabel(), parsed.getSrPlaceLabel());
	BOOST_REQUIRE_EQUAL(original.getSrPlaceConfidence(), parsed.getSrPlaceConfidence());

}

BOOST_AUTO_TEST_SUITE_END()
